IF (DEFINED HAVE_SETPROCTITLE)
    IF (HAVE_SETPROCTITLE EQUAL 0)
        IF (HAVE_CLEARENV)
            ADD_DEFINITIONS("-DHAVE_CLEARENV=1")
        ENDIF ()
        IF (HAVE_GETEXECNAME)
            ADD_DEFINITIONS("-DHAVE_GETEXECNAME=1")
        ENDIF ()
        IF (HAVE___PROGNAME)
            ADD_DEFINITIONS("-DHAVE___PROGNAME=1")
        ENDIF ()
        IF (HAVE_HAVE_PROGRAM_INVOCATION_SHORT_NAME)
            ADD_DEFINITIONS("-DHAVE_HAVE_PROGRAM_INVOCATION_SHORT_NAME=1")
        ENDIF ()
    ENDIF ()
    RETURN()
ENDIF ()

MESSAGE(STATUS "Looking for setproctitle")

SET(CMAKE_REQUIRED_QUIET TRUE)
CHECK_FUNCTION_EXISTS("setproctitle" HAVE_SETPROCTITLE)
UNSET(CMAKE_REQUIRED_QUIET)
IF (HAVE_SETPROCTITLE)
    MESSAGE(
        STATUS
        "Looking for setproctitle - found"
    )
    SET(HAVE_SETPROCTITLE 1 CACHE INTERNAL "setproctitle found on the system")
ELSE ()
    MESSAGE(
        STATUS
        "Looking for setproctitle - not found, using built-in compatibilty file"
    )
    SET(
        HAVE_SETPROCTITLE 0
        CACHE INTERNAL
        "setproctitle not found, using internal implementation"
    )

    CHECK_FUNCTION_EXISTS("clearenv" HAVE_CLEARENV)
    CHECK_FUNCTION_EXISTS("getexecname" HAVE_GETEXECNAME)
    CHECK_VARIABLE_EXISTS("__progname" HAVE___PROGNAME)
    CHECK_VARIABLE_EXISTS(
        "program_invocation_short_name" HAVE_PROGRAM_INVOCATION_SHORT_NAME
    )
    IF (HAVE_CLEARENV)
        ADD_DEFINITIONS("-DHAVE_CLEARENV=1")
    ENDIF ()
    IF (HAVE_GETEXECNAME)
        ADD_DEFINITIONS("-DHAVE_GETEXECNAME=1")
    ENDIF ()
    IF (HAVE___PROGNAME)
        ADD_DEFINITIONS("-DHAVE___PROGNAME=1")
    ENDIF ()
    IF (HAVE_HAVE_PROGRAM_INVOCATION_SHORT_NAME)
        ADD_DEFINITIONS("-DHAVE_HAVE_PROGRAM_INVOCATION_SHORT_NAME=1")
    ENDIF ()
ENDIF ()
