FIND_PATH(
    EVENT2_INCLUDE_DIR
    event2/event.h
    # OpenBSD has libevent1 in /usr/lib, always try /usr/local first:
    HINTS /usr/local/
)

FOREACH (COMPONENT ${Event2_FIND_COMPONENTS})
    STRING(TOUPPER ${COMPONENT} UPPER_COMPONENT)
    FIND_LIBRARY(
        EVENT2_${UPPER_COMPONENT}_LIBRARY event_${COMPONENT} HINTS /usr/local/
    )
    IF (EVENT2_${UPPER_COMPONENT}_LIBRARY)
        SET(Event2_${COMPONENT}_FOUND TRUE)
    ENDIF ()
ENDFOREACH ()

INCLUDE(FindPackageHandleStandardArgs)

FIND_PACKAGE_HANDLE_STANDARD_ARGS(
    Event2
    HANDLE_COMPONENTS
    REQUIRED_VARS EVENT2_CORE_LIBRARY EVENT2_INCLUDE_DIR
)
